class Geom::Vector3d
	def sc(s)
		Geom::Vector3d.new(x*s,y*s,z*s)
	end
	def sc!(s)
		self.x *= s
		self.y *= s
		self.z *= s
		self
	end
end

def v(x,y,z)
	Geom::Vector3d.new(x,y,z)
end

G = [
2214859040,
2147750176,
2356492586,
2224460077,
2224329001,
2224329001,
2226427177,
4132735182,
1048584,
6291464,
]

def T(o,d, tn)

	tn[0]=1e9 
	m=0
	p = -o.z/d.z
	if(0.01<p) 
		tn[0]=p
		tn[1]=v(0,0,1)
		m=1
	end
	
	p = v(0,0,0)
	for k in 0...32
		for j in 0...9
			if((G[j]&(1<<k))!=0)
				p.x = o.x + k*2
				p.y = o.y + 0
				p.z = o.z + j*2 - 20
				b = p.dot(d)
				c = p.dot(p)-2.25
				q = b*b-c
				if(q>0)
					s = -b - Math::sqrt(q)
					if ((s<tn[0])&&(s>0.01))
						tn[0] = s; 
						tn[1] = (p+d.sc(tn[0])).normalize 
						m=2 
					end
				end
			end
		end
	end

	return m
end

																												  
def S(o,d)

	tn = []
	m = T(o,d,tn)
	
	if(m==0)
		return v(0.5,0.9,0.9).sc!((0.9-d.z) ** 4.0)
	end

	h = o + d.sc(tn[0]) 
	l = (v(-50,-15,15)+h.sc(-1)).normalize
    r = d + tn[1].sc(tn[1].dot(d) * -2)
	b = l.dot(tn[1])
	b = 0 if(b<0 || (T(h,l,tn) > 0))
	p = (l.dot(r) * ((b>0)?1:0)) ** 96
	if(m==1)
		h = h.sc(0.2)
		return ((Integer((h.x).ceil+(h.y).ceil) & 1)==1 ? v(0.8,0.8,0.8) : v(0.8,0.4,0.1)).sc!(b * 0.75 + 0.25)
	else
		return v(p,p,p)+S(h,r).sc!(0.7)
	end
end

REZ=512
SAMPLES=32

def raytrace(filename=nil)

	filename = UI.savepanel("Save Raytrace Image", "","output.ppm") unless filename
	File.open(filename, "wb") {|f|
		f.printf("P6 #{REZ} #{REZ} 255\n")
		o = v(-65,-25,20)
		g = v(2,2.5,-1).normalize

		# use SU camera
		if false
			e = Sketchup.active_model.active_view.camera.eye
			o = v(e.x, e.y, e.z)
			t = Sketchup.active_model.active_view.camera.target - e
			g = v(t.x, t.y, t.z).normalize
		end
		
		a = (v(0,0,1).cross(g)).normalize.sc(1.8 / REZ)
		b = (g.cross(a)).normalize.sc(1.8 / REZ) 
		c = (a+b).sc(-REZ*0.5)+g
		
		for y1 in 0...REZ
			y = REZ - 1 - y1
			Sketchup.set_status_text "raytrace: line #{y1} of #{REZ}"
			for x1 in 0...REZ
				x = REZ - 1 - x1
				p = v(0,0,0)
				for r in 1..SAMPLES
					t = a.sc((rand()-0.5)*99) + b.sc((rand()-0.5)*99)
					p = S(o+t, (t.sc(-1)+(a.sc(rand()+x)+b.sc(y+rand())+c).sc!(50)).normalize) + p
				end
				p.sc!(255.0/SAMPLES)
				p += v(5,5,5)
				p.x = p.x < 255 ? p.x : 255
				p.y = p.y < 255 ? p.y : 255
				p.z = p.z < 255 ? p.z : 255
				f.printf("%c%c%c",Integer(p.x),Integer(p.y),Integer(p.z))
			end
		end
		Sketchup.set_status_text "Finished #{filename}"
	}
end

if( not file_loaded?(__FILE__) )

    menu=UI.menu("Plugins")
    menu.add_separator
    menu.add_item("Trace some Ruby Rays!") { raytrace }
    
    file_loaded(__FILE__)
end



